// TRAIN PHYSICS CODE //
// do not mess with this. At all.

function PrimeTrainPhysics(%v,%e,%d,%p,%m,%b,%startsound,%runsound,%stopsound,%idlesound,%horn,%maxspeed) {
// PrimeTrainPhysics(VEHICLE ID,ENABLE ENGINE,DRAG,ENGINE POWER,ENGINE MAX,BRAKES,START SOUND,RUN SOUND,STOP SOUND,IDLE SOUND,HORN SOUND,CONSTANT SOUND DELAY);
    if(!isObject(%v)) {
        trainsdebug("Train init failed for" SPC %v @ ": AIPlayer does not exist");
        return;
    }
    %v.controller = CreateAIClient(0);
    %v.controller.setcontrolobject(%v);
    trainsdebug("Train physics set for" SPC %v SPC "(Spawned at" SPC %v.getPosition() @ ")");
    %v.isTrain = 1;
    %v.canAlign = 1;
    %v.superAlign = 1;
    %this.allowofftrack = 0;
    %v.speed = 0;
    %v.maxspeed = %maxspeed;
    %v.drag = %d;
    %v.hasengine = %e;
    %v.enginestatus = 0; // 0 = inactive  1 = forwards  2 = reverse  3 = brake
    %v.enginepower = %p;
    %v.enginemax = %m;
    %v.hasbrakes = %b;
    %v.curtrack = 0;
    %v.lastrotbrick = 0;
    %v.canlaunch = 1;
    %v.playenginesound = 1;
    %v.enginestartdata = %startsound;
    %v.enginerundata = %runsound;
    %v.enginestopdata = %stopsound;
    %v.engineidledata = %idlesound;
    %v.hornsound = %horn;
    %v.cantt = 1;
    %v.trainLocked = 0;
    %v.tick = 0;
    %v.animation = 0;
    %v.tilt = 0;
    %v.hillmode = 0;
    
    %v.trainsoundallowed = true;
    
    $InputTarget_["Self"]   = %v.spawnbrick;
    $InputTarget_["Train"] = %v;
    $InputTarget_["Minigame"] = getMiniGameFromObject(%v.spawnbrick);
    //%v.spawnbrick.processInputEvent("OnTrainSpawn", %v.spawnbrick.client);
    
    %v.TrainLoop();
    
    trainsdebug("Started train physics, Train " @ %v @ " does" @ (isObject(%v) ? " " : " not ") @ "exist and Controller " @ %v.controller @ " does" @ (isObject(%v.controller) ? " " : " not ") @ "exist");
}
// Creates AIConnection and assigns it to vehicle(%v)

// ONLY USE THE FOLLOWING ON PRIMED TRAINS
function SetTrainSpeed(%v,%m) {
    %v.controller.setmove("y",%m);
}
// sets the forward/backward movement(%m) of the train(%v)

function SnapTrainToTrack(%this,%track,%super) {
    if(%track.getDatablock().getName() $= "brickTrainGuideS") {
        // trainturn removed
        if(%super < 2) {
            if(%track.rotation $= "0 0 -1 90.0002") {
                %this.setTransform(%this.getPosition() SPC "1 0 0 0");
                %suptrans = "1 0 0 0";
            }
            else if(%track.rotation $= "0 0 1 180") {
                %this.setTransform(%this.getPosition() SPC "0 0 -1 1.5707963");
                %suptrans = "0 0 -1 1.5707963";
            }
            else if(%track.rotation $= "0 0 1 90.0002") {
                %this.setTransform(%this.getPosition() SPC "0 0 1 3.14159265");
                %suptrans = "0 0 1 3.14159265";
            }
            else if(%track.rotation $= "1 0 0 0") {
                %this.setTransform(%this.getPosition() SPC "0 0 1 1.5707963");
                %suptrans = "0 0 1 1.5707963";
            }
        }
        if(%super >= 1) {
            %this.setTransform(%track.getPosition() SPC %suptrans);
            //%this.setVelocity(0 SPC 0 SPC 0);
            %this.superAlign = 0;
        }
    } else {
        %this.canalign = 1;
    }
}

function TrainTurn(%v,%m,%this) {
	if(!isObject(%v) && !%v.isTrain == 1 && (%this != %v.lastrotbrick || %this == -1))
		return;
	
    if(%this !$= -1) {
        %v.lastrotbrick = %this;
    }
    
	%eulerRot = axisToEuler(getWords(%v.getTransform(),3,6));
	%deg = getWord(%eulerRot,2);
    
    if(%this !$= -1) {
        %pos = %this.getPosition();
    } else {
        %pos = %v.getPosition();
    }
    
    %deg += %m;
    
    %new = eulerToAxis("0 0 " @ %deg);
	%v.setTransform(%pos SPC %new);
    
    // now for velocity
    %vel = %v.getVelocity();

    %ox = getWord( %vel, 0 );
    %oy = getWord( %vel, 1 );
    %theta = %m*0.0174532925;
    
    %cs = mCos( %theta );
    %sn = mSin( %theta );

    %nx = %ox * %cs - %oy * %sn;
    %ny = %ox * %sn + %oy * %cs;
    // THIS IS WHY WE CAN'T HAVE NICE THINGS
    
    %v.setVelocity( %nx SPC %ny SPC getWord( %vel, 2 ) );
}
// TrainTurn Makes a train(%v) turn a certain ammount(%m) on a brick (%this)

function trainTiltCheck(%this) {
    if(%this.tilt == 3) {
        %this.setLookLimits(0.28, 0);
    }
    else if(%this.tilt == 2) {
        %this.setLookLimits(0.39, 0);
    }
    else if(%this.tilt == 1) {
        %this.setLookLimits(0.48, 0);
    }
    else if(%this.tilt == 0) {
        %this.setLookLimits(1, 0);
    }
    else if(%this.tilt == -1) {
        %this.setLookLimits(1, 0.55);
    }
    else if(%this.tilt == -2) {
        %this.setLookLimits(1, 0.63);
    }
    else if(%this.tilt == -3) {
        %this.setLookLimits(1, 0.75);
    }
}

function StopTrainPhysics(%v) {
    trainsdebug("Stopping train physics, Train " @ %v @ " does" @ (isObject(%v) ? " " : " not ") @ "exist and Controller " @ %v.controller @ " does" @ (isObject(%v.controller) ? " " : " not ") @ "exist");
    %v.controller.recycle();
}
// Deletes the fake client controlling the vehicle

// PACKAGED FUNCTIONS
package TMOD
{
    // cart physics
    function Armor::onAdd(%this,%obj) {
        trainsdebug("Detected AIPlayer added!");
        parent::onAdd(%this,%obj);
        
        %data = %obj.getDatablock();
        
        if(%data.Trainmod_isTrain) {
            // new train init system!
            PrimeTrainPhysics(%obj, %data.Trainmod_engine,%data.Trainmod_drag, %data.Trainmod_enginePower, 
            %data.Trainmod_engineMax, %data.Trainmod_brakes, %data.Trainmod_startData, %data.Trainmod_runData, 
            %data.Trainmod_stopData, %data.Trainmod_idleData, %data.Trainmod_hornData, %data.Trainmod_maxSpeed);
        } else {
            trainsdebug("(Not a train)");
        }
    }
    
    function Armor::onRemove(%this,%obj) {
        trainsdebug("Detected AIPlayer removed!");
        %data = %obj.getDatablock();
        
        if(%data.Trainmod_isTrain) {
            StopTrainPhysics(%obj);
        } else {
            trainsdebug("(Not a train)");
        }
        
        // this has to come last this time
        parent::onRemove(%this,%obj);
    }
    
    // function CartArmor::onAdd(%this,%obj)
    // {
        // parent::onAdd(%this,%obj);
        // PrimeTrainPhysics(%obj, 0, 0.002, 0, 0, 1, 0, 0, "TrainBrakeSound", 0, 0, 0);
    // }
    
    // function CartArmor::onRemove(%this,%obj) {
        // StopTrainPhysics(%obj);
        // parent::onRemove(%this);
    // }
    
    // function MCartArmor::onAdd(%this,%obj)
    // {
        // parent::onAdd(%this,%obj);
        // PrimeTrainPhysics(%obj, 1, 0.002, 0.01, 0.2, 1, "TrainCartStartSound", "TrainCartRevSound", "TrainBrakeSound", 0, "TrainBellSound", 20);
    // }
    
    // function MCartArmor::onRemove(%this, %obj) {
        // StopTrainPhysics(%obj);
        // parent::onRemove(%this);
    // }
    
    // function BTrainArmor::onAdd(%this,%obj)
    // {
        // parent::onAdd(%this,%obj);
        // PrimeTrainPhysics(%obj, 1, 0.002, 0.01, 0.2, 1, 0, "TrainBoxRevSound", "TrainBrakeSound", "TrainBoxIdleSound", "TrainHornSound", 20);
    // }
    
    // function BTrainArmor::onRemove(%this,%obj) {
        // StopTrainPhysics(%obj);
        // parent::onRemove(%this);
    // }
    
    // function HorseGTArmor::onAdd(%this,%obj)
    // {
        // parent::onAdd(%this,%obj);
        // PrimeTrainPhysics(%obj, 1, 0.02, 0.01, 0.2, 0, 0, 0, 0, 0, 0, 0);
    // }
    
    // function HorseGTArmor::onRemove(%this,%obj) {
        // StopTrainPhysics(%obj);
        // parent::onRemove(%this);
    // }
    
    // make sure to delete the controller later
    
    // cart pushing (thanks, destiny)
    function Player::activateStuff(%player)
	{
        Parent::activateStuff(%player);
        
        if(!$Pref::Trains::Push == 1) {
            return;
        }

		%client = %player.client;
        
        %target = containerRayCast(%player.getEyePoint(),vectorAdd(vectorScale(vectorNormalize(%player.getEyeVector()),2),%player.getEyePoint()),$TypeMasks::PlayerObjectType,%player);
        
        if(!isObject(%target) || %target == %player || %player.getObjectMount() == %target || %target.isTrain != 1 || %target.enginestatus != 0) {
			return %v;
        }
            
        %push = %target.drag*4;
        
        if(isObject(%target.curTrack)) {
            if(%player.isCrouched() == 1) {
                %target.speed = %target.speed - %push;
            } else {
                %target.speed = %target.speed + %push;
            }
        } else { // derailed carts can still be pushed around so long as they're in neutral
            %target.addVelocity(vectorAdd(%target.getVelocity(),vectorScale(%player.getEyeVector(), 14)));
        }
    }
    
    function fxDTSBrick::onPlant(%this) {
        parent::onPlant(%this);
        if(%this.getDatablock().getName() $= "brickTrainGuideS" || %this.getDatablock().getName() $= "brickTrainGuideB" || 
        %this.getDatablock().getName() $= "brickTrainGuideSS" || %this.getDatablock().getName() $= "brickTrainGuideI" || 
        %this.getDatablock().getName() $= "brickTrainGuideCL" || %this.getDatablock().getName() $= "brickTrainGuideCR" || 
        %this.getDatablock().getName() $= "brickTrainGuideTL" || %this.getDatablock().getName() $= "brickTrainGuideTR" || 
        %this.getDatablock().getName() $= "brickTrainGuideWL" || %this.getDatablock().getName() $= "brickTrainGuideWR" || 
        %this.getDatablock().getName() $= "brickTrainGuideHU" || %this.getDatablock().getName() $= "brickTrainGuideHD" || 
        %this.getDatablock().getName() $= "brickTrainGuideVWL" || %this.getDatablock().getName() $= "brickTrainGuideVWR" ||
        %this.getDatablock().getName() $= "brickTrainGuideHSU" || %this.getDatablock().getName() $= "brickTrainGuideHGU" ||
        %this.getDatablock().getName() $= "brickTrainGuideHSD" || %this.getDatablock().getName() $= "brickTrainGuideHGD" ||
        %this.getDatablock().getName() $= "brickTrainGuideSF")
        {
            if($Pref::Trains::UC) {
                %this.setColliding(0);
            }
            
            if($Pref::Trains::UR) {
                %this.setRendering(0);
            }
        }
    }
};
activatePackage(TMOD);