// TRAINMOD CLIENT COMPONENT //
$remapDivision[$remapCount] = "Trains";
$remapName[$remapCount] = "Forward";
$remapCmd[$remapCount] = "clTrainForward";
$remapCount++;

$remapName[$remapCount] = "Reverse";
$remapCmd[$remapCount] = "clTrainReverse";
$remapCount++;

$remapName[$remapCount] = "Neutral";
$remapCmd[$remapCount] = "clTrainNeutral";
$remapCount++;

$remapName[$remapCount] = "Brake";
$remapCmd[$remapCount] = "clTrainBrake";
$remapCount++;

$remapName[$remapCount] = "Horn";
$remapCmd[$remapCount] = "clTrainHorn";
$remapCount++;

function clTrainForward(%state)
{
	// %state tells us whether they are pressing or releasing the mouse button.
	// If it is true, that means they are pressing it.
	// If it is false, that means they are releasing it.

	// We only want our command to be called when they press it, so we do this:
	if(%state)
	{
		// This is where we tell the server what we want to do
		// Send the command 'kill'. This is how you would call serverCmdKill from the client.
		commandToServer('TrainMode',"forward");
	}
}
function clTrainReverse(%state)
{
	if(%state)
	{
		commandToServer('TrainMode',"reverse");
	}
}
function clTrainBrake(%state)
{
	if(%state)
	{
		commandToServer('TrainMode',"brake");
	}
}
function clTrainNeutral(%state)
{
	if(%state)
	{
		commandToServer('TrainMode',"neutral");
	}
}

function clTrainHorn(%state) {
    if(%state)
	{
		commandToServer('trainsoundhorn');
	}
}

// RTB
RTB_addInfoTip("Train bricks can be found in the 'Trains' section of the Brick Selector.","If you're seeing this, something's wrong.","Trains");
RTB_addInfoTip("If you have a gap in your Train rail, fill it with filler guides.","If you're seeing this, something's wrong.","Trains");
RTB_addInfoTip("You can save on filler guides by using an intersection guide instead.","If you're seeing this, something's wrong.","Trains");
RTB_addInfoTip("Press <key:clTrainHorn> to use a Train's Horn!","You need to bind a key to the Train Horn to use it!","Trains");
RTB_addInfoTip("Use <key:clTrainForward>, <key:clTrainReverse>, <key:clTrainBrake> and <key:clTrainNeutral> to control your trains without commands!","You need to bind your train keybinds to use them!","Trains");